// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/RobotGoals.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/robot_goals.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/robot_goals__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'destinations'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RobotGoals & msg,
  std::ostream & out)
{
  out << "{";
  // member: robot_name
  {
    out << "robot_name: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_name, out);
    out << ", ";
  }

  // member: destinations
  {
    if (msg.destinations.size() == 0) {
      out << "destinations: []";
    } else {
      out << "destinations: [";
      size_t pending_items = msg.destinations.size();
      for (auto item : msg.destinations) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RobotGoals & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: robot_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_name: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_name, out);
    out << "\n";
  }

  // member: destinations
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.destinations.size() == 0) {
      out << "destinations: []\n";
    } else {
      out << "destinations:\n";
      for (auto item : msg.destinations) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RobotGoals & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::msg::RobotGoals & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::msg::RobotGoals & msg)
{
  return tuw_multi_robot_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::RobotGoals>()
{
  return "tuw_multi_robot_msgs::msg::RobotGoals";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::RobotGoals>()
{
  return "tuw_multi_robot_msgs/msg/RobotGoals";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::RobotGoals>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::RobotGoals>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::RobotGoals>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__TRAITS_HPP_
