// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/RouteProgress.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/route_progress.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/route_progress__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RouteProgress & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: passed
  {
    if (msg.passed.size() == 0) {
      out << "passed: []";
    } else {
      out << "passed: [";
      size_t pending_items = msg.passed.size();
      for (auto item : msg.passed) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: todo
  {
    if (msg.todo.size() == 0) {
      out << "todo: []";
    } else {
      out << "todo: [";
      size_t pending_items = msg.todo.size();
      for (auto item : msg.todo) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: progress
  {
    out << "progress: ";
    rosidl_generator_traits::value_to_yaml(msg.progress, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RouteProgress & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: passed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.passed.size() == 0) {
      out << "passed: []\n";
    } else {
      out << "passed:\n";
      for (auto item : msg.passed) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: todo
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.todo.size() == 0) {
      out << "todo: []\n";
    } else {
      out << "todo:\n";
      for (auto item : msg.todo) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: progress
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "progress: ";
    rosidl_generator_traits::value_to_yaml(msg.progress, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RouteProgress & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::msg::RouteProgress & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::msg::RouteProgress & msg)
{
  return tuw_multi_robot_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::RouteProgress>()
{
  return "tuw_multi_robot_msgs::msg::RouteProgress";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::RouteProgress>()
{
  return "tuw_multi_robot_msgs/msg/RouteProgress";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::RouteProgress>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::RouteProgress>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::RouteProgress>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__TRAITS_HPP_
