// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/RouterStatus.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/router_status.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/router_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RouterStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: missing_robots
  {
    if (msg.missing_robots.size() == 0) {
      out << "missing_robots: []";
    } else {
      out << "missing_robots: [";
      size_t pending_items = msg.missing_robots.size();
      for (auto item : msg.missing_robots) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: duration
  {
    out << "duration: ";
    rosidl_generator_traits::value_to_yaml(msg.duration, out);
    out << ", ";
  }

  // member: overall_path_length
  {
    out << "overall_path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.overall_path_length, out);
    out << ", ";
  }

  // member: longest_path_length
  {
    out << "longest_path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.longest_path_length, out);
    out << ", ";
  }

  // member: priority_scheduling_attemps
  {
    out << "priority_scheduling_attemps: ";
    rosidl_generator_traits::value_to_yaml(msg.priority_scheduling_attemps, out);
    out << ", ";
  }

  // member: speed_scheduling_attemps
  {
    out << "speed_scheduling_attemps: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_scheduling_attemps, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RouterStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: missing_robots
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.missing_robots.size() == 0) {
      out << "missing_robots: []\n";
    } else {
      out << "missing_robots:\n";
      for (auto item : msg.missing_robots) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "duration: ";
    rosidl_generator_traits::value_to_yaml(msg.duration, out);
    out << "\n";
  }

  // member: overall_path_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overall_path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.overall_path_length, out);
    out << "\n";
  }

  // member: longest_path_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longest_path_length: ";
    rosidl_generator_traits::value_to_yaml(msg.longest_path_length, out);
    out << "\n";
  }

  // member: priority_scheduling_attemps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "priority_scheduling_attemps: ";
    rosidl_generator_traits::value_to_yaml(msg.priority_scheduling_attemps, out);
    out << "\n";
  }

  // member: speed_scheduling_attemps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_scheduling_attemps: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_scheduling_attemps, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RouterStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_multi_robot_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_multi_robot_msgs::msg::RouterStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_multi_robot_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_multi_robot_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_multi_robot_msgs::msg::RouterStatus & msg)
{
  return tuw_multi_robot_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::RouterStatus>()
{
  return "tuw_multi_robot_msgs::msg::RouterStatus";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::RouterStatus>()
{
  return "tuw_multi_robot_msgs/msg/RouterStatus";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::RouterStatus>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::RouterStatus>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::RouterStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__TRAITS_HPP_
