// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/Station.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/station.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__Station __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__Station __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Station_
{
  using Type = Station_<ContainerAllocator>;

  explicit Station_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->name = "";
    }
  }

  explicit Station_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    name(_alloc),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->name = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__Station
    std::shared_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__Station
    std::shared_ptr<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Station_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const Station_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Station_

// alias to use template instance with default allocator
using Station =
  tuw_multi_robot_msgs::msg::Station_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION__STRUCT_HPP_
