// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:msg/RouteProgress.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/route_progress.h"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'passed'
// Member 'todo'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/RouteProgress in the package tuw_multi_robot_msgs.
typedef struct tuw_multi_robot_msgs__msg__RouteProgress
{
  std_msgs__msg__Header header;
  /// A list of already passed route segment id's.
  rosidl_runtime_c__int32__Sequence passed;
  /// The route segment id where the robot is currently located.
  int32_t current;
  /// A list of route segment id's which will be visited by the robot. If this list is empty, the robot has finished its route.
  rosidl_runtime_c__int32__Sequence todo;
  /// The route progress in %.
  float progress;
} tuw_multi_robot_msgs__msg__RouteProgress;

// Struct for a sequence of tuw_multi_robot_msgs__msg__RouteProgress.
typedef struct tuw_multi_robot_msgs__msg__RouteProgress__Sequence
{
  tuw_multi_robot_msgs__msg__RouteProgress * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__msg__RouteProgress__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PROGRESS__STRUCT_H_
